import 'package:drift/drift.dart';
import 'package:drift_dev/api/migrations_native.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:reckoner/database/reckoner_db.dart';

// The generated directory from before.
import 'generated_migrations/schema.dart';
import 'generated_migrations/schema_v1.dart' as v1;
import 'generated_migrations/schema_v2.dart' as v2;

void main() {
  late SchemaVerifier verifier;

  setUpAll(() {
    // GeneratedHelper() was generated by drift, the verifier is an api
    // provided by drift_dev.
    verifier = SchemaVerifier(GeneratedHelper());
  });

  test('upgrade from v1 to v2', () async {
    // Generate data that was modified in V2
    final schema = await verifier.schemaAt(1);
    final oldDb = v1.DatabaseAtV1(schema.newConnection());

    final settings = await oldDb
        .into(oldDb.userSettings)
        .insertReturning(
          v1.UserSettingsCompanion.insert(
            uuid: generateUuid(),
            navListJson: '',
          ),
        );

    final org = await oldDb
        .into(oldDb.organizations)
        .insertReturning(
          v1.OrganizationsCompanion.insert(
            name: 'Test Organization',
            uuid: generateUuid(),
          ),
        );
    final account = await oldDb
        .into(oldDb.accounts)
        .insertReturning(
          v1.AccountsCompanion.insert(
            name: 'Test Account',
            orgUuid: org.uuid,
            uuid: generateUuid(),
          ),
        );
    final location = await oldDb
        .into(oldDb.locations)
        .insertReturning(
          v1.LocationsCompanion.insert(
            uuid: generateUuid(),
            name: 'Test Location',
            address: '123 Sesame',
            city: 'New York',
            region: 'NY',
            zip: '12345',
          ),
        );
    final merchant = await oldDb
        .into(oldDb.merchants)
        .insertReturning(
          v1.MerchantsCompanion.insert(
            name: 'Test Merchant',
            uuid: generateUuid(),
            locationUuid: Value(location.uuid),
          ),
        );
    final txV1 = await oldDb
        .into(oldDb.transactions)
        .insertReturning(
          v1.TransactionsCompanion.insert(
            uuid: generateUuid(),
            accountUuid: account.uuid,
            name: 'Test Tx',
            date: DateTime.now(),
            currencyCode: 'USD',
            amount: 1000,
            merchantUuid: Value(merchant.uuid),
          ),
        );
    final txV1NoMer = await oldDb
        .into(oldDb.transactions)
        .insertReturning(
          v1.TransactionsCompanion.insert(
            uuid: generateUuid(),
            accountUuid: account.uuid,
            name: 'Test Tx',
            date: DateTime.now(),
            currencyCode: 'USD',
            amount: 1000,
          ),
        );
    await oldDb.close();

    // Need to add this as the test may run so fast that the migrated
    // settings don't have a different update date
    // ignore: inference_failure_on_instance_creation
    await Future.delayed(const Duration(seconds: 1));

    //Migrate the Database to v2
    final db = ReckonerDb.isolate(schema.newConnection());
    await verifier.migrateAndValidate(db, 2);
    await db.close();

    //Validate the data was migrated in v2
    final migratedDb = v2.DatabaseAtV2(schema.newConnection());
    final txV2 =
        await (migratedDb.select(migratedDb.transactions)
          ..where((final t) => t.uuid.equals(txV1.uuid))).getSingle();

    final txV2NoMer =
        await (migratedDb.select(migratedDb.transactions)
          ..where((final t) => t.uuid.equals(txV1NoMer.uuid))).getSingle();

    final settingsV2 =
        await migratedDb.select(migratedDb.userSettings).getSingle();

    await migratedDb.close();

    //Validate the results
    expect(txV2NoMer.updateDate, txV1NoMer.updateDate);
    expect(txV2NoMer.merchantName, null);
    assert(txV2.updateDate.isAfter(txV1.updateDate));
    expect(txV2.merchantName, merchant.name);
    expect(txV2.locationUuid, merchant.locationUuid);
    assert(settings.updateDate.isBefore(settingsV2.updateDate));
  });
}
